; STRING.ASM
; part of Ben's Command Extender
; string handling procs
; 5 Dec 97
; blm
;

; strlen
; return length of string in ax
strlen:
	push    cx
	push    si
	push    ds
	
	push    cs
	pop     ds
	mov     si, ax

	xor     cx, cx
.next_char:
	lodsb
	and     al, al
	jz      .end_found
	inc     cx
	jmp     .next_char
	
.end_found: 
	mov     ax, cx
	pop     ds
	pop     si
	pop     cx
	ret
	


; strncpy
; copy nul terminated string from ax to dx
; cx is max number of characters to copy
; returns number of characters copied
strncpy:
	push	cx
	push	dx
	push	di
	push	si
	push	ds
	push	es
	
	and		cx, cx
	jz		.done
	
	mov		si, ax
	mov		di, dx
	mov		ax, cs
	mov		ds, ax
	mov		es, ax
	
	xor		dx, dx
.next_char:
	lodsb
	and		al, al
	jz		.done
	stosb
	inc		dx
	loopnz	.next_char

.done	
	xor		al, al
	stosb
	mov		ax, dx	
	pop		es
	pop		ds
	pop		si
	pop		di
	pop		dx
	pop		cx
	ret
	
	
	
; string data

string	TIMES 256 db 00h
