; NEWLINE.ASM
; part of Ben's Command Extender
; new line handling procs
; 5 Dec 97
; blm
;



; lfon
; turn on line feeds
lfon:
	mov     word [cs:new_line], feed
	ret
	
	
	
; lfoff
; turn off line feeds
lfoff:
	mov     word [cs:new_line], no_feed
	ret
	
	

; feed
; print a carriage return and line feed to standard output
feed:
	push    ax
	push    dx
	
	mov     dl, CR
	mov     ah, 06h
	int     21h
	mov     dl, LF
	mov     ah, 06h
	int     21h
	
	pop     dx
	pop     ax
	ret
	
	
; no_feed
; do not print a carriage return and line feed to standard output
no_feed:
	ret
	


; newline data
new_line    dw feed
